package es.optsicom.problem.gop;


import java.io.File;

import es.optsicom.lib.Problem;
import es.optsicom.lib.instancefile.InstancesRepository;
import es.optsicom.lib.util.BestMode;
import es.optsicom.problem.gop.instances.GOPRepositoryInstances;

public class GOPProblem extends Problem {
	
	private static final GOPProblem INSTANCE = new GOPProblem();
	public static final String LINE_SEARCH_EVALUATIONS = "LINE_SEARCH_EVALUATIONS";
	public static final String SCORED_LS_CALLS = "SCORED_LS_CALLS";
	public static final String SIMPLEX_EVALUATIONS = "SIMPLEX_EVALUATIONS";
	
	public static GOPProblem getInstance() {
		return INSTANCE;
	}
	
	private GOPProblem() {
		super("GOP", BestMode.MIN_IS_BEST);
	}

	@Override
	public InstancesRepository getInstancesRepository(File instanceFileDir,	String useCase) {
		return new GOPRepositoryInstances(useCase);
	}

}
