package es.optsicom.problem.gop.function.cec2008;

import es.optsicom.problem.gop.GOPInstance;
import es.optsicom.problem.gop.GOPSolution;
import es.optsicom.problem.gop.function.HybridFunction;
import es.optsicom.problem.gop.instances.FunctionInstanceFile;

public class F15 extends HybridFunction {

	public F15(int dimension) {
		super("F15", dimension);
		setLowerBound(-10);
		setUpperBound(10);
	}

	@Override
	public double evaluate(GOPSolution solution) {
	    double[] part1 = new double[dimension];
	    double[] part2 = new double[dimension];
	    
	    divideFunctions(dimension, solution, part1, part2, 0.25);

	    FBohachevsky f1 = new FBohachevsky(size1);
	    GOPInstance size1Instance = new GOPInstance(new FunctionInstanceFile(null, "", "", "", f1));
	    double f1Value = f1.evaluate(new GOPSolution(size1Instance, part1));
	    FSchwefel2_22 f2 = new FSchwefel2_22(size2);
	    GOPInstance size2Instance = new GOPInstance(new FunctionInstanceFile(null, "", "", "", f2));
	    double f2Value = f2.evaluate(new GOPSolution(size2Instance, part2));

	    return f1Value + f2Value;
	}

}
