package es.optsicom.problem.gop.function.cec2008;

import es.optsicom.problem.gop.GOPSolution;
import es.optsicom.problem.gop.function.Function;

public class FSchaffer extends Function {

	public FSchaffer(int dimension) {
		super("CEC2008/" + dimension + "/F11", "f_Schaffer", dimension);
		setLowerBound(-100);
		setUpperBound(100);
	}

	@Override
	public double evaluate(GOPSolution solution) {
		int i;
		double sum, aux, aux2;
		double currentGen, nextGen;

		sum = 0.0;
		currentGen = solution.get(0);
		currentGen = currentGen * currentGen;

		for (i = 1; i < dimension; i++) {
			nextGen = solution.get(i);
			nextGen = nextGen * nextGen;
			aux = currentGen + nextGen;
			currentGen = nextGen;
			aux2 = Math.sin(50. * Math.pow(aux, 0.1));
			sum += Math.pow(aux, 0.25) * (aux2 * aux2 + 1.0);
		}

		return sum;
	}

}
